/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWETH_H
#define _NWETH_H
    

#include <sys/types.h>
#include <sys/time.h>
#include <net/if.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWETH_SIZE_ENTRY        32
#define NWETH_SIZE_INTERFACE    32
#define NWETH_SIZE_PACKET     4096
#define NWETH_SIZE_ADDRESS       6

#define NWETH_DEFAULT_FLAGS		(IFF_PROMISC)

                      
enum NwEthErrors
{
    NWETH_OK = NWETH_ERROR, 
    NWETH_PARAM, NWETH_OPEN, NWETH_NEWETH, NWETH_INIT,
    NWETH_SETUP,  NWETH_IOCTL, NWETH_BLOCK,
    NWETH_ADDLIST, NWETH_SEND, NWETH_READ, 
    NWETH_WEVENT, NWETH_EEVENT, NWETH_NEVENT,
	NWETH_CONFIG
};


typedef struct _NwEth
{
	INT   Socket;
	CHAR *Interface;
    BYTE  Address[NWETH_SIZE_ADDRESS];
	INT   Flags;
	BYTE  Buf[NWETH_SIZE_PACKET];
	INT   BufSize;
	LONG  Pos;
	LONG  End;
	         
} NwEth;
    

typedef struct _NwEthDg
{          
    NW_DG  NwInfo;
    NwEth  EthInfo;
    
    BLOCK           *Block;
    
    struct _NwEthDg *Prev;
    struct _NwEthDg *Next;
    
} NwEthDg;

      

extern NW_DG_IFACE EthDgIface;


BOOLEAN NwEthInit(VOID);
BOOLEAN NwEthExit(VOID);

NW_DG  *NwEthAccept(char *addr, NW_DG_RECV_CALL recv, VOID *param);
NW_DG  *NwEthConnect(char *addr, NW_DG_RECV_CALL recv, VOID *param);
BOOLEAN NwEthSend(NW_DG *dg, BYTE *frame, INT len);
BOOLEAN NwEthSendTo(NW_DG *dg, char *addr, BYTE *frame, INT len);
BOOLEAN NwEthClose(NW_DG *dg);
BOOLEAN NwEthIfConfig(NW_DG *dg, NW_IFCONFIG *ifconfig);


#endif
