/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWNIT_H
#define _NWNIT_H
    

#include <sys/types.h>
#include <sys/time.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWNIT_SIZE_ENTRY        32
#define NWNIT_SIZE_INTERFACE    32
#define NWNIT_SIZE_PACKET     4096
#define NWNIT_SIZE_ADDRESS       6

/* only add flags, don't delete any otherwise the code may break */
#define NWNIT_DEFAULT_FLAGS     (NI_TIMESTAMP | NI_DROPS | NI_LEN)

#define NWNITDEVICE     "/dev/nit"
#define NWNITFILTER     "pf"
#define NWNITBUFFER     "nbuf"

                      
enum NwNitErrors
{
    NWNIT_OK = NWNIT_ERROR, 
    NWNIT_PARAM, NWNIT_INIT, NWNIT_ROOT,
    NWNIT_OPEN, NWNIT_SETUP, NWNIT_IOCTL, NWNIT_PUSH, 
    NWNIT_NEWNIT, 
    NWNIT_ADDLIST, NWNIT_BLOCK,
    NWNIT_READ, NWNIT_SEND,     
    NWNIT_WEVENT, NWNIT_EEVENT, NWNIT_NEVENT,
	NWNIT_CONFIG
};


typedef struct nit_bufhdr   NITBUFHDR;
typedef struct nit_iftime   IFTIME;
typedef struct nit_ifdrops  IFDROPS;
typedef struct nit_iflen    IFLEN;


typedef struct _NwNit
{
	INT Socket;
	CHAR *Interface;
    BYTE  Address[NWNIT_SIZE_ADDRESS];
	ULONG BufSize;
	ULONG SnapLen;
	TIMEVAL Timeout;
	ULONG Flags;
	BYTE *Buf;
	LONG  Pos;
	LONG  End;
	         
} NwNit;
    

typedef struct _NwNitDg
{          
    NW_DG  NwInfo;
    NwNit  NitInfo;
    
    BLOCK          *Block;
    
    struct _NwNitDg *Prev;
    struct _NwNitDg *Next;
    
} NwNitDg;

      

extern NW_DG_IFACE NitDgIface;


BOOLEAN NwNitInit(VOID);
BOOLEAN NwNitExit(VOID);

NW_DG  *NwNitAccept(char *addr, NW_DG_RECV_CALL recv, VOID *param);
NW_DG  *NwNitConnect(char *addr, NW_DG_RECV_CALL recv, VOID *param);
BOOLEAN NwNitSend(NW_DG *dg, BYTE *frame, INT len);
BOOLEAN NwNitSendTo(NW_DG *dg, char *addr, BYTE *frame, INT len);
BOOLEAN NwNitClose(NW_DG *dg);
BOOLEAN NwNitIfConfig(NW_DG *dg, NW_IFCONFIG *ifconfig);


#endif
